USE MyAdventureGame
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Forums_Messages_Expanded]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[Forums_Messages_Expanded]
GO



CREATE VIEW [dbo].[Forums_Messages_Expanded] AS
SELECT [Forum_Id] = M.[Forum_Id],
       [Message_Id] = M.[Message_Id], 
       [Last_Post_Id] = LP.[Post_Id],
       [Last_Username] = LP.[Username],
       [Last_Post_Date] = LP.[Post_Date],
       [Last_Subject] = LP.[Subject],
       [First_Post_Id] = FP.[Post_Id],
       [First_Username] = FP.[Username],
       [First_Post_Date] = FP.[Post_Date],
       [First_Subject] = FP.[Subject],
       [Post_Count] = P.[Post_Count],
	   [Pinned_Id] = FMP.[Pinned_Id],
       
       [Feature_Status] = 
         CASE [Forum_Id]
           WHEN 7 THEN
             COALESCE(FF.[Status], 'New')
           ELSE 'N/A'
         END,
       [Feature_Acceptance_Date] = FF.[Acceptance_Date],
       [Feature_Acceptance_Comments] = FF.[Acceptance_Comments],
       [Feature_Completion_Date] = FF.[Completion_Date],
       [Feature_Completion_Comments] = FF.[Completion_Comments],
 
       [Bug_Status] = 
         CASE [Forum_Id]
           WHEN 8 THEN
             CASE 
               WHEN BR.[Resolution_Date] IS NULL THEN 'Open'
               ELSE 'Closed'
             END
           ELSE 'N/A'
         END,
       [Bug_Resolution_Date] = BR.[Resolution_Date],
       [Bug_Resolution_Comments] = BR.[Resolution_Comments],

       [Sort_Order] =
         CASE [Forum_Id]
           WHEN 7 THEN
             CHARINDEX(COALESCE(FF.[Status], 'New'),'NewAcceptedRejectedCompleted')
           WHEN 8 THEN
             CASE 
               WHEN BR.[Resolution_Date] IS NULL THEN 1
               ELSE 2
             END
           ELSE 1
         END

  FROM [Forums_Messages] M
       INNER JOIN (SELECT [Message_Id], 
                          [First_Post_Id] = MIN([Post_Id]),
                          [Last_Post_Id] = MAX([Post_Id]),
                          [Post_Count] = COUNT([Post_Id])
                     FROM [Forums_Posts]
                    GROUP BY [Message_Id]) P
               ON P.[Message_Id] = M.[Message_Id]
       INNER JOIN [Forums_Posts] FP
               ON P.[First_Post_Id] = FP.[Post_Id]
       INNER JOIN [Forums_Posts] LP
               ON P.[Last_Post_Id] = LP.[Post_Id]
        LEFT JOIN [Forums_Bug_Resolutions] BR
               ON P.[Message_Id] = BR.[Message_Id]
        LEFT JOIN [Forums_Features] FF
               ON P.[Message_Id] = FF.[Message_Id]
	    LEFT JOIN [Forums_Messages_Pinned] FMP
		       ON P.[Message_Id] = FMP.[Message_Id]





GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

